#!/usr/bin/env bash
set -v
###########################################################
# Evaluation of reading access performance                #
# with 3 data structures :                                #
#  - simple array (contiguous access),                    #
#  - dynamic array (contiguous access),                   #
#  - simple array (random access),                        #
# Memory bandwidth is outputed by each thread (OpenMP)    #
# First run the program for an array size of 2 GB         #
# and perform an average of the timings over 2 measures.  #
# The program has a loop that divides the array size by   #
# 2 and multiply the number of measures to take by 2, in  #
# order to scan decreasing sizes of arrays                #
# WARNING: if you choose to change TSIZE, be careful to   #
#          change REPEAT parameter in order to keep       #
#          reasonable time measures (not to small < .1s   #
#          and not too large > 10s                        #
###########################################################
./comp.sh -DTSIZE=2*1024*1024 -DREPEAT=2
# Change the value of OMP_NUM_THREADS to increase thread number
#export OMP_NUM_THREADS=1
./dynarray
