#!/usr/bin/env bash
pexec () {  echo $1; $1; };
if [ -z "$(which icc)" ]; then
  echo "#gcc compiler used"
  CC=gcc
  SFLAGS="-O3 -fopenmp"
else
  echo "#intel icc compiler used"
  CC=icc 
  SFLAGS="-O3 -openmp"
fi
CFLAGS="${SFLAGS} $* -Wall -DTIMER -DOPTIM"
pexec "$CC $CFLAGS -c sum.c"
pexec "$CC $CFLAGS -c dynarray.c"
pexec "$CC $CFLAGS -o dynarray sum.o dynarray.o -lm"
