#include "sum.h"
#include <assert.h>

element sum_array(element *array, int size) {
  register int     i;
  register element sumval = 0;
#ifdef OPTIM
  int              sdiv2 = size/2;
  assert(size>2);
  for (i=0; i<sdiv2; i++) {
    sumval += array[i];
    sumval += array[sdiv2+i];
  }
#else
  for (i=0; i<size; i++) {
    sumval += array[i];
  }
#endif
  return sumval;
}

element sum_rand_array(element *array, int size) {
  register int      i;
  register element  sumval = 0;
  register long int     seed, mask;
  register int arand  = 1664525L;
  register int brand  = 1013904223L;
  // test if size is a power of two
  assert((size&(~size+1))==size);
  seed = MYSEED;
  mask = size-1;
  for (i=0; i<size; i++) {
    seed = ( arand * seed + brand) & 0xFFFFFFFF;
    sumval += array[seed & mask];
  }
  return sumval;
}

element sum_dynarray(dynarray *darray, int size) {
  register int     i;
  register element sumval = 0;
#ifdef OPTIM
  int              sdiv2 = size/2;
  for (i=0; i<sdiv2; i++) {
    sumval += darray->array[i];
    sumval += darray->array[sdiv2+i];
  }
#else
  for (i=0; i<size; i++) {
    sumval += darray->array[i];
  }
#endif
  return sumval;
}

