#!/usr/bin/env bash
set -v
###########################################################
# Evaluation of reading access performance                #
# with 2 general tree data structures:                    #
#  - based on linked list,                                #
#  - based on dynamic arrays.                             #
# Memory bandwidth is outputed by each thread (OpenMP)    #
# WARNING: if you choose to change TSIZE, be careful to   #
#          change REPEAT parameter in order to keep       #
#          reasonable time measures (not to small < .1s   #
#          and not too large > 10s                        #
###########################################################
./comp.sh -DTSIZE=32*1024 -DNBREPEAT=400
# Change the value of OMP_NUM_THREADS to increase thread number
#export OMP_NUM_THREADS=1
./gtree
