#define MYSEED 2
#define MAXWIDTH 20000

struct sdata {
  double  val;
  int64_t key;
};
typedef struct sdata data;

struct gtree_linked_s {  
  struct sdata   object;
  struct gtree_linked_s *leftChild; 
  struct gtree_linked_s *rightSibling; 
};
typedef struct gtree_linked_s gtree_linked;

struct gtree_array_elt_s {  
  struct sdata object;
  int32_t      leftChild; 
  int32_t      parent; 
  int32_t      rightSibling; 
};

typedef struct gtree_array_elt_s gtree_array_elt;
typedef gtree_array_elt element;
struct sdynarray {
  int size;
  int capacity;
  element *array;
};
typedef struct sdynarray gtree_array;

struct queue_gt1_s {
  int start;
  int end;
  gtree_linked* tab[MAXWIDTH];
};
typedef struct queue_gt1_s queue_gt1;

struct queue_gt3_s {
  int start;
  int end;
  gtree_array_elt* tab[MAXWIDTH];
};
typedef struct queue_gt3_s queue_gt3;


#define IRANDMAX ((float)(1./(0x100000000LL)))

#define MYRAND(longlong) \
    (longlong = (1664525LL * longlong + 1013904223LL) & 0xFFFFFFFFLL)



#define  INITQUEUE(_queue) \
  { _queue->start = 0; _queue->end = 0; }
#define  ENQUEUE(_queue,_node)	{					\
  _queue->tab[_queue->end]=_node;					\
  _queue->end=(_queue->end+1)%MAXWIDTH;				\
  assert(_queue->start != _queue->end);					\
  }
#define  DEQUEUE(_queue,_node) {					\
    assert(_queue->start != _queue->end);				\
    _node = _queue->tab[_queue->start];					\
    _queue->start=(_queue->start+1)%MAXWIDTH;				\
  }
#define  NOTEMPTYQUEUE(_queue) (_queue->start != _queue->end)

#define  PUSHSTACK(_stack,_size,_node) { \
    _stack[(_size)++] = _node;		 \
    assert((_size) < MAXWIDTH-1);	 \
}
#define   POPSTACK(_stack,_size,_node) { \
    _node = _stack[--(_size)];		 \
}
#define  STACKNOTEMPTY(_size)          ((_size) != 0)


gtree_linked *gtree_linked_malloc();
void alloc_fill_gtree_linked(gtree_linked *gt1, int size, queue_gt1 *queue1);
void alloc_fill_gtree_array(gtree_array *gt3, int size);

void gtree_array_breadthfirst_traversal(gtree_array *gt3, queue_gt3 *queue3);
void gtree_array_breadthfirst_copy(gtree_array *gt3, gtree_array *copy, queue_gt3 *queue3);
void gtree_array_traversal(gtree_array *pgt3);

double gtree_array_sumval(gtree_array *gt3);
double gtree_linked_breadthfirst_sumval(gtree_linked *gt1, queue_gt1 *queue1);
double gtree_array_breadthfirst_sumval(gtree_array *gt3, queue_gt3 *queue3);

double repeat_sum_gtree_array(gtree_array *gt3, int repeat);
double repeat_breadthfirst_sum_gtree_linked(gtree_linked *gt1, int repeat, queue_gt1 *queue1);
double repeat_breadthfirst_sum_gtree_array(gtree_array *gt3, int repeat, queue_gt3 *queue3);

