#!/usr/bin/env bash
set -v
############################################################
# Perform adaptive computation based on Haar scheme.       #
# A 1D function is advected with constant displacements.   #
# Periodic boundary conditions are used. At the end, the   #
# signal (file 'sparsef_end.dat') should be at roughly     #
# the same place as initially (file sparsef_beg.dat').     #
# compile programs with small data input size TSIZE=4*1024 #
############################################################
./comp.sh -DDRATE=4 -DDEBUG -DTSIZE=4*1024
###################### HASH  ################################
./haar_hash
###################### ARRAY ################################
./haar_array
./rm.sh
############################################################
# compile programs with larger data input size             #
############################################################
./comp.sh -DDEBUG -DTSIZE=2*1024*1024
###################### HASH  ################################
./haar_hash
###################### ARRAY ################################
./haar_array

