#!/usr/bin/env bash
pexec () {  echo $1; $1; };
if [ -z "$(which icc)" ]; then
  echo "#gcc compiler used"
  CC=gcc
  SFLAGS="-O3 -Wall"
else
  echo "#intel icc compiler used"
  CC=icc 
  SFLAGS="-O3"
fi
CFLAGS="${SFLAGS} -DTIMER $*"
pexec "$CC $1 $CFLAGS -D_HASH -c `pkg-config --cflags glib-2.0` hash.c"
pexec "$CC $1 $CFLAGS -D_HASH -c `pkg-config --cflags glib-2.0` haar_adapt.c"
pexec "$CC $1 $CFLAGS -D_HASH -c `pkg-config --cflags glib-2.0` haar_main.c"
pexec "$CC -o haar_hash hash.o haar_adapt.o haar_main.o -lm `pkg-config --libs glib-2.0`"
pexec "$CC $1 $CFLAGS -c haar_adapt.c"
pexec "$CC $1 $CFLAGS -c haar_main.c"
pexec "$CC -o haar_array haar_adapt.o haar_main.o -lm"

