
#include <glib.h>
#include <math.h>
#include "haar.h"
#include "hash.h"

void hash_init_table(hashtable **phatab, int nbelts) {
  int i, nblevel;
  hashtable *hatab;
  double fnblevel;
  fnblevel    = log2(((double)nbelts));
  nblevel     = (int)fnblevel;
  hatab       = (hashtable *)   malloc(sizeof(struct shashtable));
  *phatab     = hatab;
  hatab->keys = (_KEYTYPE*) malloc (nbelts*sizeof(_KEYTYPE));
  hatab->vals = (_VALTYPE*) malloc (nbelts*sizeof(_VALTYPE));
  hatab->ends = (int*) malloc((nblevel+2)*sizeof(int));
  hatab->hash = g_hash_table_new(g_int_hash, g_int_equal);
  hatab->maxsize = nbelts;
  hatab->cursize = 0;
  for(i = 0; i < nbelts; i++) {
    //    if (i%(nbelts/100)==0) printf("elt %d size %d \n",i,nbelts);
    hatab->keys[i] = 0;
    hatab->vals[i] = 0;
  }
}

void hash_destroy_table(hashtable **phatab) {
  hashtable *hatab;
  hatab = *phatab;
  free(hatab->keys);
  free(hatab->vals);
  g_hash_table_destroy(hatab->hash);
  free(hatab);
  *phatab = NULL;
}

