#include <glib.h>
#include <math.h>

#ifndef HASH_H
#define HASH_H

#define _TABTYPE GHashTable

struct shashtable {
  _KEYTYPE *keys;
  _VALTYPE *vals;
  _TABTYPE *hash;
  int   *ends;
  int maxsize;
  int cursize;
};

typedef struct shashtable hashtable;

void hash_init_table(hashtable **phatab, int nbelts);
void hash_destroy_table(hashtable **phatab);


#define _INITF(_phatab,_size) hash_init_table(_phatab,_size)

#define _DESTROY(_phatab) hash_destroy_table(_phatab)

#define _RESETF(_hatab,_size) {\
  g_hash_table_steal_all(_hatab->hash);		\
  _hatab->cursize = 0;				\
  }

#define _GET_SIZE(_hatab,_size) {		\
  _size=g_hash_table_size(_hatab->hash);		\
  }

#define _SETF_NEW(_hatab,_key,_val) {					\
    if (_hatab->cursize-1 >= _hatab->maxsize) {		\
      printf("error out of bound in _SETADDF\n");fflush(stdout);exit(2); \
    }									\
    _hatab->keys[_hatab->cursize] = _key;			\
    _hatab->vals[_hatab->cursize] = _val;			\
    g_hash_table_insert(_hatab->hash,			\
			(gpointer)&(_hatab->keys[_hatab->cursize]),	\
			(gpointer)&(_hatab->vals[_hatab->cursize]));	\
    (_hatab->cursize)++;						\
  }

#define _SETF_MODIFY(_hatab,_key,_val,_ind) {			\
    if (_ind >= _hatab->maxsize) {					\
      printf("error out of bound in _SETINDEXF\n");fflush(stdout);exit(2); \
    }			\
    _hatab->keys[_ind] = _key;						\
    _hatab->vals[_ind] = _val;						\
    g_hash_table_insert(_hatab->hash,					\
			(gpointer)&(_hatab->keys[_ind]),		\
			(gpointer)&(_hatab->vals[_ind]));		\
    _hatab->cursize=(_ind+1>_hatab->cursize?_ind+1:_hatab->cursize);	\
  }

#define _GETPOINTER(_hatab,_key,_pval) {			     \
    _pval=((double*)g_hash_table_lookup(_hatab->hash,(void*)&_key)); \
  }

#define _GETF(_hatab,_key,_val)	{					\
    _VALTYPE* _pval=((double*)g_hash_table_lookup(_hatab->hash,(void*)&_key)); \
    _val=((_pval == NULL)?NOTAVALUE:*(_pval));				\
  }

#endif
