#ifndef HAAR_H
#define HAAR_H

#ifdef DEBUG
#define WAVDEBUG(expr) expr
#else
#define WAVDEBUG(expr) 
#endif


void haar_predict( double* vec, int itc, int N, int dir ); 
void haar_update( double* vec, int itc, int N, int dir );
void haar_ftransform( double *ts, int N );
void haar_itransform( double *ts, int N );

int haar_level(int input, int nblevel);

void haar_thresholding( double *vec, int N,
			double normcoef, 
			double threshold );
void haar_fdwt(double* vec, int N);
void haar_idwt(double* vec, int N); 

#endif
