#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdint.h>

inline void clockget_ (int64_t *timepoint) {
  struct timeval tv2;
  gettimeofday(&tv2, (struct timezone*)0);
  timepoint[0] = (tv2).tv_sec;
  timepoint[1] = (tv2).tv_usec;
}

inline double clockdiff_ (int64_t *tp1, int64_t *tp2) {
  return((tp2[0]-tp1[0])+0.000001*(tp2[1]-tp1[1]));
}

#ifdef TIMER
#define GETTIME(expr,message) {	               \
  int64_t t1[2], t2[2];                        \
  clockget_(t1);expr;clockget_(t2);             \
  printf("%s %lf\n",message,clockdiff_(t1,t2));	\
}
#else
#define GETTIME(expr,message) expr
#endif
