#ifndef HAAR_H
#define HAAR_H

#ifdef DEBUG
#define WAVDEBUG(expr) expr
#else
#define WAVDEBUG(expr) 
#endif

void haar_printintermediate(double *ts, int N);
void haar_predict( double* vec, int N, int dir );
void haar_split( double* ts, double* tmpvec, int N );

void haar_merge( double* ts, double* tmpvec, int N );
void haar_update( double* vec, int N, int dir );
void haar_ftransform( double *ts, double *tmpvec, int N );
void haar_itransform( double *ts, double *tmpvec, int N );
void haar_thresholding( double *vec, int N, 
			double normcoef , 
			double threshold );
void haar_fdwt(double* vec, double *ts, int N);
void haar_idwt(double* vec, double *ts, int N);
#endif
