#!/usr/bin/env bash
set -v
###########################################################
# Evaluation of hash table (glib2) performance            #
# Remark: To compile you nead to install glib2 packages   #
# e.g. 'libglib2.0-0' 'libglib2.0-0-dev'                  #
# The parameter TSIZE parameterize the size of the dense  #
# array of size N, the parameter STRIDE parameterizes the #
# sparsity of the storage. If STRIDE==100, the hash table # 
# contains S=N/100 elements.                              #
# The program benchmarks:                                 #
#  - the traversal of the dense array (size N),           #
#  - the traversal of the hash table (size S=N/STRIDE),   #
#  - perform N lookups in the hash table (size S).        #
###########################################################
./comp.sh -DTSIZE=40*1000*1000 -DSTRIDE=15
# Change the value of OMP_NUM_THREADS to increase thread number
#export OMP_NUM_THREADS=1
./hash
