#!/usr/bin/env bash
set -v
###########################################################
# Evaluation of hash table (glib2) memory requirements    #
# Remark: To compile you nead to install glib2 packages   #
# e.g. 'libglib2.0-0' 'libglib2.0-0-dev'                  #
# The parameter TSIZE parameterize the size of the dense  #
# array of size N, the parameter STRIDE parameterizes the #
# sparsity of the storage. If STRIDE==100, the hash table # 
# contains S=N/100 elements.                              #
# The program outputs memory consumption                  #
#  - at the start of the program.                         #
#  - after the allocation of the array (size N).          #
#  - after the fill of the hash table (size S).           #
# The program waits for one ENTER hit after each          #
# output. It allows the user for eventually check the     #
# size of the process during execution.                   # 
###########################################################
./comp.sh -DTSIZE=30*1000*1000 -DSTRIDE=1
export OMP_NUM_THREADS=1
./hash_mem
