#!/usr/bin/env bash
set -v
###########################################################
# Evaluation of matrix-multiply subroutines               #
# using the three following versions:                     #
#  - basic implementation,           ,                    #
#  - call to BLAS routine 'dgemm',                        #
#  - blocked algorithm.                                   #
# You need to install BLAS library, or MKL (provided with #
# Intel compiler icc) in order to compile this program.   #
# Time measurements are outputed by each thread (OpenMP)  #
###########################################################
./comp.sh -DTSIZE=1024 -DREPEAT=1
# Change the value of OMP_NUM_THREADS to increase thread number
#export OMP_NUM_THREADS=1
./matmul
