#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>
#include <stdlib.h>


inline void clockget_ (int64_t *timepoint) {
  struct timeval tv2;
  gettimeofday(&tv2, (struct timezone*)0);
  timepoint[0] = (tv2).tv_sec;
  timepoint[1] = (tv2).tv_usec;
}

inline double clockdiff_ (int64_t *tp1, int64_t *tp2) {
  return((tp2[0]-tp1[0])+0.000001*(tp2[1]-tp1[1]));
}

#ifdef TIMER
#define GETTIME(expr,message) {	               \
  int64_t t1[2], t2[2];                        \
  clockget_(t1);expr;clockget_(t2);             \
  printf("%s %lf\n",message,clockdiff_(t1,t2));	\
}
#define GETBWIDTH(expr,bsize,message) {		 \
  int64_t t1[2], t2[2]; double tsec;		 \
  clockget_(t1);expr;clockget_(t2);			\
  tsec=clockdiff_(t1,t2);tsec=(tsec<1e-30?1e-30:tsec);	\
  printf("%-40s time %15lf bandwidth %20lf GB/s\n",message,		\
	 tsec,bsize/(tsec*1024.*1024.*1024.));				\
 }
#else
 #define GETTIME(expr,message) expr
#define GETBWIDTH(expr,bsize,message) expr
#endif
