#!/usr/bin/env bash
set -v
############################################################
# Perform adaptive computation based on Lifting scheme.    #
# A 2D function is compressed.                             #
# Periodic boundary conditions are used.                   #
# Compile programs with input sizes from TSIZE=256         #
# to TSIZE=16*1024.                                        #
# The 2D computational domain will be of size TSIZE^2      #
############################################################
./comp.sh -DDEBUG -DTSIZE="(4*1024)" -DMODEX=16
###################### PTREE ################################
./wav_ptree
###################### HASH  ################################
./wav_hash
###################### ARRAY ################################
./wav_array
./rm.sh

