#!/usr/bin/env bash
pexec () {  echo $1; $1; };
if [ -z "$(which icc)" ]; then
  echo "#gcc compiler used"
  CC=gcc
  SFLAGS="-O3 -Wall"
else
  echo "#intel icc compiler used"
  CC=icc 
  SFLAGS="-O3"
fi
# -DCOUNT_COLL  -DDEBUG
CFLAGS="${SFLAGS} -DTIMER $* "
pexec "$CC $CFLAGS -c clock.c"
pexec "$CC $CFLAGS -c meminfo.c"

pexec "$CC $CFLAGS -D_PTREE -c ptree.c"
pexec "$CC $CFLAGS -D_PTREE -c wav_adapt.c"
pexec "$CC $CFLAGS -D_PTREE -c wav_main.c"
pexec "$CC -o wav_ptree clock.o meminfo.o ptree.o wav_adapt.o wav_main.o -lm"

pexec "$CC $CFLAGS -D_HASH -c `pkg-config --cflags glib-2.0` hash.c"
pexec "$CC $CFLAGS -D_HASH -c `pkg-config --cflags glib-2.0` wav_adapt.c"
pexec "$CC $CFLAGS -D_HASH -c `pkg-config --cflags glib-2.0` wav_main.c"
pexec "$CC -o wav_hash clock.o meminfo.o hash.o wav_adapt.o wav_main.o -lm `pkg-config --libs glib-2.0`"
#
pexec "$CC $CFLAGS -c wav_adapt.c"
pexec "$CC $CFLAGS -c wav_main.c"
pexec "$CC -o wav_array clock.o meminfo.o wav_adapt.o wav_main.o -lm"


