#include <glib.h>
#include <math.h>
#include "sstruct.h"

#ifdef GUINT_LONG
/* (sqrt(5) - 1) * 2^63 */
#define HASH_CONST 11400714819323198485
#else
/* (sqrt(5) - 1) * 2^31 */
#define HASH_CONST 2654435769
#endif


guint
hashfunc_knuth (gconstpointer v) {
  // Multiply by the golden ratio                                                                                                                                                                              
  // (Knuth, Art of Computer Programming, Vol 3, Section 6.4                                                                                                                                                   
  return HASH_CONST* (*(const guint*) v);
}

int
main(int argc, char **argv)
{
  guint i,j;
  for (i=0; i<90; i++) {
    j = hashfunc_knuth((gconstpointer)&i)%1009;
    printf ("i=%6u res=%20u\n",i,j);
  }
}
