#ifndef SSTRUCT_H
#define SSTRUCT_H

#define _KEYTYPE uint32_t
#define _VALTYPE float
#define NOTAVALUE ((_VALTYPE)1e30)
#define FORBIDDEN ((_VALTYPE)-1e29)
#define _KEYXY(_kx,_ky) ((((_KEYTYPE)_kx)<<16)+(_KEYTYPE)_ky)
#define _INVKEYXY(_key,_kx,_ky) {_ky=((_KEYTYPE)_key)&(_KEYTYPE)0xFFFFUL;_kx=((_KEYTYPE)_key)>>16;}

#ifdef _HASH

#include "hash.h"
#define FTYPE hashtable

#else /* HASH */

#ifdef _PTREE /* PTREE */

#include "ptree.h"
#define FTYPE ptrees

#else
/* use simple dense arrays */
#include "dense.h"
#define FTYPE _VALTYPE

#endif /* PTREE */
#endif /* HASH */

#endif /* SSTRUCT */
