#include <stdlib.h>
#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "sstruct.h"

#ifndef WAV_H
#define WAV_H

#define _XY(_ix,_iy,_size) (_ix+_iy*_size)

#ifdef DEBUG
#define WAVDEBUG(expr) expr
#else
#define WAVDEBUG(expr) 
#endif


void wav_init(int type);
void wav_update_x(_VALTYPE* fwav, int itc, int N, int dir );
void wav_predict_x(_VALTYPE* fwav, int itc, int N, int dir );
void wav_update_y(_VALTYPE* fwav, int itc, int N, int dir );
void wav_predict_y(_VALTYPE* fwav, int itc, int N, int dir );
void wav_ftransform( _VALTYPE *fwav, int N );
void wav_itransform( _VALTYPE *fwav, int N );
void wav_reorder_grid(FTYPE *snew, int N );
void wav_copyfunc_aa( _VALTYPE *fold, _VALTYPE *fnew, int N );
void wav_copyfunc_as( _VALTYPE *fold, FTYPE *snew, int N);
void wav_copyfunc_ss( FTYPE *sold, FTYPE *snew, int N);
void wav_copyfunc_sa( FTYPE *sold, _VALTYPE *fnew, int N);
void wav_review( FTYPE *sold, int N );
void wav_thresholding( _VALTYPE *fwav, int N, double normcoef , 
		       double maxthreshold, double zerovalue, 
		       char *grid, int *advised_shift);
void wav_adapt_itransform( FTYPE *sold, int N);
void wav_copyfunc_aa_select( _VALTYPE *fold, _VALTYPE *fnew, int N, char *grid, double value );
void wav_getkb( FTYPE *sold, int N);
void wav_flushcache(int mbsize);
void wav_adapt_predict_x(FTYPE *sdata, int itc, int N, int dir);
void wav_adapt_predict_y(FTYPE *sdata, int itc, int N, int dir);
#endif
